#pragma hdrstop
#include <condefs.h>

#include <iostream.h>
#include <conio.h>

class TCVoiture{
        protected:
        int FPFiscale;
        double FKm;
        int FAge;
        public:
        TCVoiture();//affecte des valeurs par dfaut
        virtual void saisie();//saisie des valeurs des champs
        virtual double taxe();
        };

class TCVoitureSociete:public TCVoiture{
        public:
        virtual double taxe();//redfinit la fonction taxe
        };

class TCVoitureAdministration:public TCVoitureSociete{
        private:
        int FSecteur;
        public:
        virtual void saisie();
        virtual double taxe();
        };

TCVoiture::TCVoiture()
{
        FPFiscale = 0;
        FKm = 0;
        FAge = 0;
}

void TCVoiture:: saisie()
{
        cin >> FPFiscale;
        cin >> FKm;
        cin >> FAge;
}

double TCVoiture::taxe()
{
        double temp = 100.0*FPFiscale-45.0*FAge-0.5*FKm ;
        if (temp<0)
                temp = 0.0;
        return temp;
}

//qui est r-crite pour la classe TCVoiture socit
double TCVoitureSociete::taxe()
{
        double temp = 150.0*FPFiscale-23.0*FAge-0.1*FKm;
        if (temp<0)
                temp = 0.0;
        return temp;
}

void TCVoitureAdministration::saisie()
{
        TCVoitureSociete::saisie();
        cin >> FSecteur;
}

double TCVoitureAdministration::taxe()
{
        double temp = TCVoitureSociete::taxe();
        if (FSecteur == 1)
                temp = temp/2.0;
        return temp;
}

//---------------------------------------------------------------------------
#pragma argsused
int main(int argc, char* argv[])
{
        cout << "type de vhicule (0 - voiture / 1 - socit / 2 - administration) : ";

        int typev;
        cin >> typev;

        //type dclar
        TCVoiture* v;

        //initialisation avec le type rel
        switch (typev)
        {
                case 0 : v = new TCVoiture();
                         break;
                case 1 : v = new TCVoitureSociete();
                         break;
                default : v = new TCVoitureAdministration();
        }

        v->saisie();//saisie du type initialis est utilis

        cout << v->taxe();//idem, taxe du type rellement initialis

        delete v;

        getch();
        
        return 0;
}
